searchNodes=[{"ref":"CloudAPI.html","title":"CloudAPI","type":"module","doc":"This module is responsible for tying all CloudAPI related functionality together into one context."},{"ref":"CloudAPI.html#add_machine_tags/4","title":"CloudAPI.add_machine_tags/4","type":"function","doc":"Set tags on the given instance. A pre-existing tag with the same name as one given will be overwritten. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: String that represents the id of the machine. tags: Map of Key-Value assignment of tags."},{"ref":"CloudAPI.html#add_nic/4","title":"CloudAPI.add_nic/4","type":"function","doc":"Creates a new NIC on an instance belonging to a given account. WARNING: this causes the instance to reboot while adding the NIC. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. machine_id: String that represents the machine id. network_id: String that represents the network id."},{"ref":"CloudAPI.html#change_user_password/4","title":"CloudAPI.change_user_password/4","type":"function","doc":"This is a separate rule for password changes, so different policies can be used for an user trying to modify other data, or only their own password. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: UUID that represents the ID of the User. password: String that represents the new password."},{"ref":"CloudAPI.html#clone_image/3","title":"CloudAPI.clone_image/3","type":"function","doc":"Creates an independent copy of the source image. The login account must be on the source image ACL to be able to make an image clone. The resulting cloned image will have the same properties as the source image, but the cloned image will have a different id, it will be owned by the login account and the image will have an empty ACL. All incremental images in the image origin chain that are not operator images (i.e. are not owned by admin) will also be cloned, though all cloned incremental images will have state disabled so that they are not visible in the default image listings. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: String that represents the image id to clone."},{"ref":"CloudAPI.html#create_fabric_network/4","title":"CloudAPI.create_fabric_network/4","type":"function","doc":"Create a fabric Network on a VLAN. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. vlan_id: String that represents the VLAN id. network: %CloudAPI.Network{} with the details you want updated."},{"ref":"CloudAPI.html#create_fabric_vlan/3","title":"CloudAPI.create_fabric_vlan/3","type":"function","doc":"Creates a new VLAN on the fabric. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: String that represents the VLAN id."},{"ref":"CloudAPI.html#create_firewall_rule/3","title":"CloudAPI.create_firewall_rule/3","type":"function","doc":"Adds a new firewall rule for the specified account. This rule will be added to all the account&#39;s instances where it may be necessary. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. fwrule: %CloudAPI.FirewallRule{} with the details you want updated."},{"ref":"CloudAPI.html#create_image_from_machine/3","title":"CloudAPI.create_image_from_machine/3","type":"function","doc":"Creates an image from a virtual machine. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. create_image: %CloudAPI.CreateImageFromMachine{} with the details you want updated."},{"ref":"CloudAPI.html#create_key/3","title":"CloudAPI.create_key/3","type":"function","doc":"Uploads a new OpenSSH key to Triton for use in HTTP signing and SSH. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. account: %CloudAPI.Key{} with the details you want created."},{"ref":"CloudAPI.html#create_machine/3","title":"CloudAPI.create_machine/3","type":"function","doc":"Allows you to provision an instance. If you do not specify a name, CloudAPI will generate a random one for you. If you have enabled Triton CNS on your account, this name will also be used in DNS to refer to the new instance (and must therefore consist of DNS-safe characters only). Your instance will initially be not available for login (Triton must provision and boot it); you can poll GetMachine for its status. When the state field is equal to running, you can log in. If the instance is a brand other than kvm or bhyve, you can usually use any of the SSH keys managed under the keys section of CloudAPI to login as any POSIX user on the OS. You can add/remove keys over time, and the instance will automatically work with that set. If the the instance has a brand kvm or bhyve, and of a UNIX-derived OS (e.g. Linux), you must have keys uploaded before provisioning; that entire set of keys will be written out to /root/.ssh/authorized_keys in the new instance, and you can SSH in using one of those keys. Changing the keys over time under your account will not affect a running hardware virtual machine in any way; those keys are statically written at provisioning-time only, and you will need to manually manage them on the instance itself. If the image you create an instance from is set to generate passwords for you, the username/password pairs will be returned in the metadata response as a nested object, like so: &quot;metadata&quot;: { &quot;credentials&quot;: { &quot;root&quot;: &quot;s8v9kuht5e&quot;, &quot;admin&quot;: &quot;mf4bteqhpy&quot; } } You cannot overwrite the credentials key in CloudAPI. More generally, the metadata keys can be set either at the time of instance creation, or after the fact. You must either pass in plain-string values, or a JSON-encoded string. On metadata retrieval, you will get a JSON object back. Networks can be specified using the networks attribute. It is possible to have an instance attached to an internal network, external network or both. If the networks attribute is absent from the input, the instance will be attached to one externally-accessible network (i.e. assigned a public IP), and any one of internal/private networks. If the account owns or has access to multiple private networks, it will be important to include the desired network(s) in the request payload instead of letting the system assign the network automatically. Be aware that CreateMachine does not return IP addresses or networks. To obtain the IP addresses and networks of a newly-provisioned instance, poll GetMachine until the instance state is running. Typically, Triton will allocate the new instance somewhere reasonable within the cloud. See affinity rules below for options on controlling server placement of new instances. When Triton CNS is enabled, the DNS search domain of the new VM will be automatically set to the suffix of the &quot;instance&quot; record that is created for that VM. For example, if the full CNS name of the new VM would be &quot;foo.inst.35ad1ec4-2eab-11e6-ac02-8f56c66976a1.us-west-1.triton.zone&quot;, its automatic DNS search path would include &quot;inst.35ad1ec4-2eab-11e6-ac02-8f56c66976a1.us-west-1.triton.zone&quot;. This can be changed later within the instance, if desired. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. machine: %CloudAPI.CreateMachine{} with the details you want updated."},{"ref":"CloudAPI.html#create_machine_snapshot/4","title":"CloudAPI.create_machine_snapshot/4","type":"function","doc":"Allows you to take a snapshot of an instance. Once you have one or more snapshots, you can boot the instance from a previous snapshot. Snapshots are not usable with other instances; they are a point-in-time snapshot of the current instance. Snapshots can also only be taken of instances that are not of brand &#39;kvm&#39; or &#39;bhyve&#39;. Since instance instances use a copy-on-write filesystem, snapshots take up increasing amounts of space as the filesystem changes over time. There is a limit to how much space snapshots are allowed to take. Plan your snapshots accordingly. You can poll on get_machine_snapshot until the state is created. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: String that represents the id of the machine. name: String that represents the name of the snapshot."},{"ref":"CloudAPI.html#create_policy/3","title":"CloudAPI.create_policy/3","type":"function","doc":"Creates an account policy. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. policy: %CloudAPI.Policy{} with the details you want updated."},{"ref":"CloudAPI.html#create_role/3","title":"CloudAPI.create_role/3","type":"function","doc":"Create an account role. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. role: %CloudAPI.Role{} with the details you want updated."},{"ref":"CloudAPI.html#create_user/3","title":"CloudAPI.create_user/3","type":"function","doc":"Creates a new user under an account. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. user: %CloudAPI.Account{} with the details you want created."},{"ref":"CloudAPI.html#create_user_key/4","title":"CloudAPI.create_user_key/4","type":"function","doc":"Create a SSH Key for a user. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. user: String that represents the users id or name. key: %CloudAPI.Key{} with the details you want updated."},{"ref":"CloudAPI.html#create_volume/3","title":"CloudAPI.create_volume/3","type":"function","doc":"Create a new volume for the account. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. volume: %CloudAPI.Volume{} with the details you want updated."},{"ref":"CloudAPI.html#delete_all_machine_metadata/3","title":"CloudAPI.delete_all_machine_metadata/3","type":"function","doc":"Deletes all metadata keys from this instance. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: String that represents the id of the machine."},{"ref":"CloudAPI.html#delete_all_machine_tags/3","title":"CloudAPI.delete_all_machine_tags/3","type":"function","doc":"Deletes all tags from an instance asynchronously. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: String that represents the id of the machine."},{"ref":"CloudAPI.html#delete_fabric_network/4","title":"CloudAPI.delete_fabric_network/4","type":"function","doc":"Delete a fabric Network on a VLAN. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. vlan_id: String that represents the VLAN id. id: String that represents the Network id."},{"ref":"CloudAPI.html#delete_fabric_vlan/3","title":"CloudAPI.delete_fabric_vlan/3","type":"function","doc":"Delete a fabric VLAN. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: String that represents the VLAN id."},{"ref":"CloudAPI.html#delete_firewall_rule/3","title":"CloudAPI.delete_firewall_rule/3","type":"function","doc":"Removes the given firewall rule from all the required instances. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: String that represents the id of the Firewall Rule."},{"ref":"CloudAPI.html#delete_image/3","title":"CloudAPI.delete_image/3","type":"function","doc":"Delete image by id. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: String represents the image id."},{"ref":"CloudAPI.html#delete_key/3","title":"CloudAPI.delete_key/3","type":"function","doc":"Deletes a single SSH key, by name or fingerprint. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. name_or_fingerprint: String that is either the Fingerprint of the SSH Key or it&#39;s name as it appears in the Cloud Portal."},{"ref":"CloudAPI.html#delete_machine/3","title":"CloudAPI.delete_machine/3","type":"function","doc":"Delete a machine. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: String that represents the id of the machine to be deleted."},{"ref":"CloudAPI.html#delete_machine_metadata/4","title":"CloudAPI.delete_machine_metadata/4","type":"function","doc":"Deletes a single metadata key from this instance. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: String that represents the id of the machine. key: String that represents the metadata key."},{"ref":"CloudAPI.html#delete_machine_snapshot/4","title":"CloudAPI.delete_machine_snapshot/4","type":"function","doc":"Deletes the specified snapshot of an instance. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: String that represents the id of the machine. name: String that represents the name of the snapshot."},{"ref":"CloudAPI.html#delete_machine_tag/4","title":"CloudAPI.delete_machine_tag/4","type":"function","doc":"Deletes a single tag from this instance asynchronously. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: String that represents the id of the machine. tag: String that represents the tag name."},{"ref":"CloudAPI.html#delete_policy/3","title":"CloudAPI.delete_policy/3","type":"function","doc":"Deletes an account policy. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: String that represents the policy id."},{"ref":"CloudAPI.html#delete_role/3","title":"CloudAPI.delete_role/3","type":"function","doc":"Delete an account role by name or id. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. role: %CloudAPI.Role{} with the details you want updated."},{"ref":"CloudAPI.html#delete_user/3","title":"CloudAPI.delete_user/3","type":"function","doc":"Remove a user. They will no longer be able to use this API. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: UUID that represents the ID of the User."},{"ref":"CloudAPI.html#delete_user_key/4","title":"CloudAPI.delete_user_key/4","type":"function","doc":"Delete a user&#39;s SSH Key by its name or fingerprint. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. user: String that represents the users id or name. name_or_fingerprint: String that represents the SSH Key&#39;s name or fingerprint."},{"ref":"CloudAPI.html#delete_volume/3","title":"CloudAPI.delete_volume/3","type":"function","doc":"Deletes a volume for the account. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: String represents the volume id."},{"ref":"CloudAPI.html#disable_firewall_rule/3","title":"CloudAPI.disable_firewall_rule/3","type":"function","doc":"Disables the given firewall rule if it is enabled. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: String that represents the id of the Firewall Rule."},{"ref":"CloudAPI.html#disable_machine_deletion_protection/3","title":"CloudAPI.disable_machine_deletion_protection/3","type":"function","doc":"Disable Deletion Protection on an instance. An instance can be destroyed after it is disabled. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: String that represents the id of the machine."},{"ref":"CloudAPI.html#disable_machine_firewall/3","title":"CloudAPI.disable_machine_firewall/3","type":"function","doc":"Disables the machine&#39;s firewall. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: String that represents the id of the machine."},{"ref":"CloudAPI.html#enable_firewall_rule/3","title":"CloudAPI.enable_firewall_rule/3","type":"function","doc":"Enables the given firewall rule if it is disabled. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: String that represents the id of the Firewall Rule."},{"ref":"CloudAPI.html#enable_machine_deletion_protection/3","title":"CloudAPI.enable_machine_deletion_protection/3","type":"function","doc":"Enable Deletion Protection on an instance. An instance can no longer be destroyed until the protection is disabled. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: String that represents the id of the machine."},{"ref":"CloudAPI.html#enable_machine_firewall/3","title":"CloudAPI.enable_machine_firewall/3","type":"function","doc":"Enables the machine&#39;s firewall. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: String that represents the id of the machine."},{"ref":"CloudAPI.html#export_image/4","title":"CloudAPI.export_image/4","type":"function","doc":"Exports an image to a Manta server. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: String represents the image id. manta_path: String represents the Manta&#39;s URL."},{"ref":"CloudAPI.html#get_account/2","title":"CloudAPI.get_account/2","type":"function","doc":"Retrieves your account details. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;."},{"ref":"CloudAPI.html#get_config/2","title":"CloudAPI.get_config/2","type":"function","doc":"Gets your configuration. Mostly docker related. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;."},{"ref":"CloudAPI.html#get_fabric_network/4","title":"CloudAPI.get_fabric_network/4","type":"function","doc":"Gets a fabric Network on a VLAN. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. vlan_id: String that represents the VLAN id. id: String that represents the Network id."},{"ref":"CloudAPI.html#get_fabric_vlan/3","title":"CloudAPI.get_fabric_vlan/3","type":"function","doc":"Gets a VLAN on the fabric by its id. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: String that represents the VLAN id."},{"ref":"CloudAPI.html#get_firewall_rule/3","title":"CloudAPI.get_firewall_rule/3","type":"function","doc":"Retrieves an individual firewall rule. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: String that represents the Firewall Rule id."},{"ref":"CloudAPI.html#get_image/3","title":"CloudAPI.get_image/3","type":"function","doc":"Get an image by its id. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: String represents the image id."},{"ref":"CloudAPI.html#get_key/3","title":"CloudAPI.get_key/3","type":"function","doc":"Retrieves the record for an individual key. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. name_or_fingerprint: String that is either the Fingerprint of the SSH Key or it&#39;s name as it appears in the Cloud Portal."},{"ref":"CloudAPI.html#get_machine/3","title":"CloudAPI.get_machine/3","type":"function","doc":"Gets the details for an individual instance. Deleted instances are returned only if the instance history has not been purged from Triton. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: String that represents the machine id."},{"ref":"CloudAPI.html#get_machine_metadata/4","title":"CloudAPI.get_machine_metadata/4","type":"function","doc":"Returns a single metadata entry associated with this instance. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: String that represents the id of the machine. key: String that represents the metadata key."},{"ref":"CloudAPI.html#get_machine_snapshot/4","title":"CloudAPI.get_machine_snapshot/4","type":"function","doc":"Gets the state of the named snapshot. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: String that represents the id of the machine. name: String that represents the name of the snapshot."},{"ref":"CloudAPI.html#get_machine_tag/4","title":"CloudAPI.get_machine_tag/4","type":"function","doc":"Returns the value for a single tag on this instance. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: String that represents the id of the machine. tag: String that represents the tag name."},{"ref":"CloudAPI.html#get_migration/3","title":"CloudAPI.get_migration/3","type":"function","doc":"Get a migration status. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: String that represents the id of the migration."},{"ref":"CloudAPI.html#get_network/3","title":"CloudAPI.get_network/3","type":"function","doc":"Retrieves information about an individual network. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: String that represents the Network id."},{"ref":"CloudAPI.html#get_network_ip/4","title":"CloudAPI.get_network_ip/4","type":"function","doc":"Get a network&#39;s IP. On a public network you can only get an IP owned by you. On private network you can get an IP owned by any of the network&#39;s shared owners, however the belongs_to_uuid field will be omitted if you do not own the instance the IP is assocaited with. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: String that represents the Network id. ip: String that represents the IP."},{"ref":"CloudAPI.html#get_nic/4","title":"CloudAPI.get_nic/4","type":"function","doc":"Gets a specific NIC on an instance belonging to a given account. NB: the :mac element in the path must have all the colons (&#39;:&#39;) stripped from it in the request. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. machine_id: String that represents the machine id. mac: String that represents the NIC&#39;s MAC Address."},{"ref":"CloudAPI.html#get_package/3","title":"CloudAPI.get_package/3","type":"function","doc":"Gets a package by id or name. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: String that represents the package&#39;s id or name."},{"ref":"CloudAPI.html#get_policy/3","title":"CloudAPI.get_policy/3","type":"function","doc":"Get an account policy by its id. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: String that represents the policy id."},{"ref":"CloudAPI.html#get_role/3","title":"CloudAPI.get_role/3","type":"function","doc":"Get an account role by id or name. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: String represents the role id or name."},{"ref":"CloudAPI.html#get_user/3","title":"CloudAPI.get_user/3","type":"function","doc":"Get one user for an account. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: UUID that represents the ID of the User."},{"ref":"CloudAPI.html#get_user_key/4","title":"CloudAPI.get_user_key/4","type":"function","doc":"Get a user&#39;s SSH Key by its name or fingerprint. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. user: String that represents the users id or name. name_or_fingerprint: String that represents the SSH Key&#39;s name or fingerprint."},{"ref":"CloudAPI.html#get_volume/3","title":"CloudAPI.get_volume/3","type":"function","doc":"Retrieves information about a single volume. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: String represents the volume id."},{"ref":"CloudAPI.html#import_image_from_datacenter/4","title":"CloudAPI.import_image_from_datacenter/4","type":"function","doc":"This will copy the image with the given id from the source datacenter into this datacenter. The copied image will retain all fields as the original image. All incremental images in the origin chain will also be copied. You can use the list_datacenters Method to get all datacenters and their names. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. datacenter: String that represents the Datacenter. id: String that represents the image id to copy."},{"ref":"CloudAPI.html#list_datacenters/1","title":"CloudAPI.list_datacenters/1","type":"function","doc":"Lists all available Datacenters and their endpoints."},{"ref":"CloudAPI.html#list_fabric_networks/3","title":"CloudAPI.list_fabric_networks/3","type":"function","doc":"Lists all of the networks in a fabric on the VLAN specified by VLAN ID. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: String that represents the VLAN id."},{"ref":"CloudAPI.html#list_fabric_vlans/2","title":"CloudAPI.list_fabric_vlans/2","type":"function","doc":"CloudAPI provides a way to create and manipulate a fabric. On the fabric you can create VLANs, and then under that create layer three networks. A fabric is the basis for building your own private networks that cannot be accessed by any other user. It represents the physical infrastructure that makes up a network; however, you don&#39;t have to cable or program it. Every account has its own unique fabric in every datacenter. On a fabric, you can create your own VLANs and layer-three IPv4 networks. You can create any VLAN from 0-4095, and you can create any number of IPv4 networks on top of the VLANs, with all of the traditional IPv4 private addresses spaces -- 10.0.0.0/8, 192.168.0.0/16, and 172.16.0.0/12 -- available for use. You can create networks on your fabrics to create most network topologies. For example, you could create a single isolated private network that nothing else could reach, or you could create a traditional configuration where you have a database network, a web network, and a load balancer network, each on their own VLAN. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;."},{"ref":"CloudAPI.html#list_firewall_rules/2","title":"CloudAPI.list_firewall_rules/2","type":"function","doc":"List all firewall rules for the current account. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;."},{"ref":"CloudAPI.html#list_firewall_rules_machines/3","title":"CloudAPI.list_firewall_rules_machines/3","type":"function","doc":"Lists all instances a firewall rule is applied to, in the same format as list_machines. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. rule_id: String that represents the Firewall Rule id."},{"ref":"CloudAPI.html#list_images/2","title":"CloudAPI.list_images/2","type":"function","doc":"Lists all available images. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;."},{"ref":"CloudAPI.html#list_keys/2","title":"CloudAPI.list_keys/2","type":"function","doc":"Lists all public keys we have on record for the specified account. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;."},{"ref":"CloudAPI.html#list_machine_firewall_rules/3","title":"CloudAPI.list_machine_firewall_rules/3","type":"function","doc":"This has exactly the same input and output format as list_firewall_rules, but just for the rules affecting the given machine. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. machine_id: String that represents the machine id."},{"ref":"CloudAPI.html#list_machine_metadata/4","title":"CloudAPI.list_machine_metadata/4","type":"function","doc":"Returns the complete set of metadata associated with this instance. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: String that represents the id of the machine. credentials: Boolean that represents if the API should return credentials stored in metadata."},{"ref":"CloudAPI.html#list_machine_snapshots/3","title":"CloudAPI.list_machine_snapshots/3","type":"function","doc":"Lists all snapshots taken for a given instance. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: String that represents the id of the machine."},{"ref":"CloudAPI.html#list_machine_tags/3","title":"CloudAPI.list_machine_tags/3","type":"function","doc":"Returns the complete set of tags associated with this instance. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: String that represents the id of the machine."},{"ref":"CloudAPI.html#list_machines/2","title":"CloudAPI.list_machines/2","type":"function","doc":"Lists all instances we have on record for your account. If you have a large number of instances, you can filter using the input parameters listed below. Note that deleted instances are returned only if the instance history has not been purged from Triton. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;."},{"ref":"CloudAPI.html#list_migrations/2","title":"CloudAPI.list_migrations/2","type":"function","doc":"Triton supports incremental offline migrations starting with CloudAPI version 9.6.0. It is possible to migrate (move a VM) to another CN using these APIs. See RFD 34 for the background on how and why instance migration works the way it does. VM migration operates in three distinct phases, the begin phase creates a hidden target placeholder vm for which to migrate into, the sync phase will synchronize the underlying filesystems and the switch phase will shutdown the original source vm, perform a final filesystem synchronization, hide the original source VM and then enable and restart the target VM. A migration can be set to run all of these phases in one (automatic migration) or these phases can each be run manually (on demand migration). For any migration action (e.g. begin, sync, switch or abort) you can use the migration watch endpoint to show progress information for the running migration action. Once the migration switch is complete, if you are happy with the new migrated instance then you should run the finalize action to remove the original source instance. Note that once the finalize action completes successfully, the migration will no longer show up in the migration list. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;."},{"ref":"CloudAPI.html#list_network_ips/3","title":"CloudAPI.list_network_ips/3","type":"function","doc":"List a network&#39;s IPs. On a public network only IPs owned by the user will be returned. On a private network all IPs that are either reserved or allocated will be returned. Note that not every network from ListNetworks will work. Some UUIDs are for pools which are not supported at this time. However, every network UUID from get_machine and get_nic will work, as they are UUIDs for a specific network. The reserved field determines if the IP can be used automatically when provisioning a new instance. If reserved is set to true, then the IP will not be given out. The managed field in the IP object tells you if the IP is manged by Triton itself. An example of this is the gateway and broadcast IPs on a network. If the IP is associated with an instance then owner_uuid will be shown as well, so that on shared private networks it is clear who is using the IP. The belongs_to_uuid field will tell you which instance owns the IP if any, and will only be present if that instance is owned by you. You can paginate this API by passing in offset and limit. HTTP responses will contain the additional headers x-resource-count and x-query-limit. If x-resource-count is less than x-query-limit, you&#39;re done, otherwise call the API again with offset set to offset + limit to fetch additional instances. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: String that represents the Network id."},{"ref":"CloudAPI.html#list_networks/2","title":"CloudAPI.list_networks/2","type":"function","doc":"List all the networks which can be used by the given account. If a network was created on a fabric, then additional information will be shown: Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;."},{"ref":"CloudAPI.html#list_nics/3","title":"CloudAPI.list_nics/3","type":"function","doc":"List all the NICs on an instance belonging to a given account. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. machine_id: String that represents the machine id."},{"ref":"CloudAPI.html#list_packages/2","title":"CloudAPI.list_packages/2","type":"function","doc":"Provides a list of packages available in this datacenter. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;."},{"ref":"CloudAPI.html#list_policies/2","title":"CloudAPI.list_policies/2","type":"function","doc":"Lists all account policies. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;."},{"ref":"CloudAPI.html#list_roles/2","title":"CloudAPI.list_roles/2","type":"function","doc":"Returns an array of account roles. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;."},{"ref":"CloudAPI.html#list_services/1","title":"CloudAPI.list_services/1","type":"function","doc":"Lists all available services like Manta."},{"ref":"CloudAPI.html#list_user_keys/3","title":"CloudAPI.list_user_keys/3","type":"function","doc":"Lists all SSH keys for a user. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. user: String that represents the users id or name."},{"ref":"CloudAPI.html#list_users/2","title":"CloudAPI.list_users/2","type":"function","doc":"Returns a list of an account&#39;s user objects. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;."},{"ref":"CloudAPI.html#list_volumes/2","title":"CloudAPI.list_volumes/2","type":"function","doc":"Returns a list of all volumes for the account. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;."},{"ref":"CloudAPI.html#machine_audit/3","title":"CloudAPI.machine_audit/3","type":"function","doc":"Provides a list of an instance&#39;s accomplished actions. Results are sorted from newest to oldest action. Note that the complete audit trail is returned only if the instance history and job records have not been purged from Triton. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: String that represents the id of the machine."},{"ref":"CloudAPI.html#migrate/5","title":"CloudAPI.migrate/5","type":"function","doc":"Migrates a Machine to another server. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: String that represents the id of the migration. action: String that represents the action to take, usually begin or watch. affinity: Array that represents the affinity rules. Only applies when actions are begin or automatic."},{"ref":"CloudAPI.html#reboot_machine/3","title":"CloudAPI.reboot_machine/3","type":"function","doc":"Reboot a machine. You can poll with get_machine for the current state. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: String that represents the id of the machine."},{"ref":"CloudAPI.html#remove_nic/4","title":"CloudAPI.remove_nic/4","type":"function","doc":"Removes a NIC on an instance belonging to a given account. Like AddNic above, the NIC won&#39;t be removed from the instance immediately. After the NIC is removed, it will start returning 404 through CloudAPI. WARNING: this causes the instance to reboot while removing the NIC. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. machine_id: String that represents the machine id. mac: String that represents the NIC&#39;s MAC Address."},{"ref":"CloudAPI.html#rename_machine/4","title":"CloudAPI.rename_machine/4","type":"function","doc":"Rename an instance. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: String that represents the id of the machine. name: String that represents the new name of the machine."},{"ref":"CloudAPI.html#replace_machine_tags/4","title":"CloudAPI.replace_machine_tags/4","type":"function","doc":"Fully replace all tags on an instance with the given tags. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: String that represents the id of the machine. tags: Map of Key-Value assignment of tags."},{"ref":"CloudAPI.html#resize_machine/4","title":"CloudAPI.resize_machine/4","type":"function","doc":"Resizing is only supported for containers (instances which are not hardware virtual machines -- they have brand=kvm or brand=bhyve). Hardware virtual machines cannot be resized. Resizing is not guaranteed to work, especially when resizing upwards in resources. It is best-effort, and may fail. Resizing downwards will usually succeed. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: String that represents the id of the machine. package_id: String that represents the id of the target package."},{"ref":"CloudAPI.html#start_machine/3","title":"CloudAPI.start_machine/3","type":"function","doc":"Start a machine. You can poll with get_machine for the current state. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: String that represents the id of the machine."},{"ref":"CloudAPI.html#start_machine_from_snapshot/4","title":"CloudAPI.start_machine_from_snapshot/4","type":"function","doc":"If an instance is in the &#39;stopped&#39; state, you can choose to start the instance from the referenced snapshot. This is effectively a means to roll back instance state. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: String that represents the id of the machine. name: String that represents the name of the snapshot."},{"ref":"CloudAPI.html#stop_machine/3","title":"CloudAPI.stop_machine/3","type":"function","doc":"Stop a machine. You can poll with get_machine for the current state. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: String that represents the id of the machine."},{"ref":"CloudAPI.html#update_account/3","title":"CloudAPI.update_account/3","type":"function","doc":"Updates your account details. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. account: %CloudAPI.Account{} with the details you want updated."},{"ref":"CloudAPI.html#update_config/3","title":"CloudAPI.update_config/3","type":"function","doc":"Updates your account configuration. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. config: %CloudAPI.Config{} with the details you want updated."},{"ref":"CloudAPI.html#update_fabric_network/4","title":"CloudAPI.update_fabric_network/4","type":"function","doc":"Update a fabric Network on a VLAN. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. vlan_id: String that represents the VLAN id. network: %CloudAPI.Network{} with the details you want updated."},{"ref":"CloudAPI.html#update_fabric_vlan/3","title":"CloudAPI.update_fabric_vlan/3","type":"function","doc":"Updates a fabric VLAN. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. vlan: %CloudAPI.VLAN{} with the details you want updated."},{"ref":"CloudAPI.html#update_firewall_rule/3","title":"CloudAPI.update_firewall_rule/3","type":"function","doc":"Updates the given rule record and -- depending on rule contents -- adds/removes/updates the rule on all the required instances. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. fwrule: %CloudAPI.FirewallRule{} with the details you want updated."},{"ref":"CloudAPI.html#update_image/3","title":"CloudAPI.update_image/3","type":"function","doc":"Updates an image. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. image: %CloudAPI.Image{} with the details you want updated."},{"ref":"CloudAPI.html#update_machine_metadata/4","title":"CloudAPI.update_machine_metadata/4","type":"function","doc":"Allows you to update the metadata for a given instance. Note that updating the metadata via CloudAPI will result in the metadata being updated in the running instance. The semantics of this call are subtly different that the AddMachineTags call -- any metadata keys passed in here are created if they do not exist, and overwritten if they do. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. id: String that represents the id of the machine. metadata: Map of Key-Value to store as metadata."},{"ref":"CloudAPI.html#update_policy/3","title":"CloudAPI.update_policy/3","type":"function","doc":"Updates an account policy. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. policy: %CloudAPI.Policy{} with the details you want updated."},{"ref":"CloudAPI.html#update_role/3","title":"CloudAPI.update_role/3","type":"function","doc":"Updates an account role. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. role: %CloudAPI.Role{} with the details you want updated."},{"ref":"CloudAPI.html#update_user/3","title":"CloudAPI.update_user/3","type":"function","doc":"Update a user&#39;s modifiable properties. Note: Password changes are not allowed using this endpoint; there is an additional change_user_password Method for password changes so it can be selectively allowed/disallowed for users using policies. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. user: %CloudAPI.Account{} with the details you want created."},{"ref":"CloudAPI.html#update_volume/3","title":"CloudAPI.update_volume/3","type":"function","doc":"Update a volume for the account. Parameters dc: %CloudAPI.Datacenter{} with the details for how to connect to this datacenter. login: String that represents the Cloud Portal Login. Defaults to &quot;my&quot;. volume: %CloudAPI.Volume{} with the details you want updated."},{"ref":"CloudAPI.Account.html","title":"CloudAPI.Account","type":"module","doc":""},{"ref":"CloudAPI.Client.html","title":"CloudAPI.Client","type":"module","doc":"This client takes care of communication with a Joyent Triton cluster via CloudAPI HTTP REST calls."},{"ref":"CloudAPI.Client.html#auth_headers/1","title":"CloudAPI.Client.auth_headers/1","type":"function","doc":""},{"ref":"CloudAPI.Client.html#delete/3","title":"CloudAPI.Client.delete/3","type":"function","doc":"Issues a DELETE request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information."},{"ref":"CloudAPI.Client.html#delete!/3","title":"CloudAPI.Client.delete!/3","type":"function","doc":"Issues a DELETE request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information."},{"ref":"CloudAPI.Client.html#get/3","title":"CloudAPI.Client.get/3","type":"function","doc":"Issues a GET request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information."},{"ref":"CloudAPI.Client.html#get!/3","title":"CloudAPI.Client.get!/3","type":"function","doc":"Issues a GET request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information."},{"ref":"CloudAPI.Client.html#head/3","title":"CloudAPI.Client.head/3","type":"function","doc":"Issues a HEAD request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information."},{"ref":"CloudAPI.Client.html#head!/3","title":"CloudAPI.Client.head!/3","type":"function","doc":"Issues a HEAD request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information."},{"ref":"CloudAPI.Client.html#options/3","title":"CloudAPI.Client.options/3","type":"function","doc":"Issues an OPTIONS request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information."},{"ref":"CloudAPI.Client.html#options!/3","title":"CloudAPI.Client.options!/3","type":"function","doc":"Issues a OPTIONS request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information."},{"ref":"CloudAPI.Client.html#patch/4","title":"CloudAPI.Client.patch/4","type":"function","doc":"Issues a PATCH request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information."},{"ref":"CloudAPI.Client.html#patch!/4","title":"CloudAPI.Client.patch!/4","type":"function","doc":"Issues a PATCH request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information."},{"ref":"CloudAPI.Client.html#post/4","title":"CloudAPI.Client.post/4","type":"function","doc":"Issues a POST request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information."},{"ref":"CloudAPI.Client.html#post!/4","title":"CloudAPI.Client.post!/4","type":"function","doc":"Issues a POST request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information."},{"ref":"CloudAPI.Client.html#process_headers/1","title":"CloudAPI.Client.process_headers/1","type":"function","doc":"Callback implementation for HTTPoison.Base.process_headers/1."},{"ref":"CloudAPI.Client.html#process_request_body/1","title":"CloudAPI.Client.process_request_body/1","type":"function","doc":"Callback implementation for HTTPoison.Base.process_request_body/1."},{"ref":"CloudAPI.Client.html#process_request_headers/1","title":"CloudAPI.Client.process_request_headers/1","type":"function","doc":"Callback implementation for HTTPoison.Base.process_request_headers/1."},{"ref":"CloudAPI.Client.html#process_request_options/1","title":"CloudAPI.Client.process_request_options/1","type":"function","doc":"Callback implementation for HTTPoison.Base.process_request_options/1."},{"ref":"CloudAPI.Client.html#process_request_params/1","title":"CloudAPI.Client.process_request_params/1","type":"function","doc":"Callback implementation for HTTPoison.Base.process_request_params/1."},{"ref":"CloudAPI.Client.html#process_request_url/1","title":"CloudAPI.Client.process_request_url/1","type":"function","doc":"Callback implementation for HTTPoison.Base.process_request_url/1."},{"ref":"CloudAPI.Client.html#process_response/1","title":"CloudAPI.Client.process_response/1","type":"function","doc":"Callback implementation for HTTPoison.Base.process_response/1."},{"ref":"CloudAPI.Client.html#process_response_body/1","title":"CloudAPI.Client.process_response_body/1","type":"function","doc":"Callback implementation for HTTPoison.Base.process_response_body/1."},{"ref":"CloudAPI.Client.html#process_response_chunk/1","title":"CloudAPI.Client.process_response_chunk/1","type":"function","doc":"Callback implementation for HTTPoison.Base.process_response_chunk/1."},{"ref":"CloudAPI.Client.html#process_response_headers/1","title":"CloudAPI.Client.process_response_headers/1","type":"function","doc":"Callback implementation for HTTPoison.Base.process_response_headers/1."},{"ref":"CloudAPI.Client.html#process_response_status_code/1","title":"CloudAPI.Client.process_response_status_code/1","type":"function","doc":"Callback implementation for HTTPoison.Base.process_response_status_code/1."},{"ref":"CloudAPI.Client.html#process_status_code/1","title":"CloudAPI.Client.process_status_code/1","type":"function","doc":"Callback implementation for HTTPoison.Base.process_status_code/1."},{"ref":"CloudAPI.Client.html#process_url/1","title":"CloudAPI.Client.process_url/1","type":"function","doc":"Callback implementation for HTTPoison.Base.process_url/1."},{"ref":"CloudAPI.Client.html#put/4","title":"CloudAPI.Client.put/4","type":"function","doc":"Issues a PUT request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information."},{"ref":"CloudAPI.Client.html#put!/4","title":"CloudAPI.Client.put!/4","type":"function","doc":"Issues a PUT request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information."},{"ref":"CloudAPI.Client.html#request/1","title":"CloudAPI.Client.request/1","type":"function","doc":"Issues an HTTP request using a Request struct. This function returns {:ok, response} or {:ok, async_response} if the request is successful, {:error, reason} otherwise. Examples request = %HTTPoison.Request{ method: :post, url: &quot;https://my.website.com&quot;, body: &quot;{\\&quot;foo\\&quot;: 3}&quot;, headers: [{&quot;Accept&quot;, &quot;application/json&quot;}] } request(request)"},{"ref":"CloudAPI.Client.html#request/5","title":"CloudAPI.Client.request/5","type":"function","doc":"Issues an HTTP request with the given method to the given url. This function is usually used indirectly by get/3, post/4, put/4, etc Args: method - HTTP method as an atom (:get, :head, :post, :put, :delete, etc.) url - target url as a binary string or char list body - request body. See more below headers - HTTP headers as an orddict (e.g., [{&quot;Accept&quot;, &quot;application/json&quot;}]) options - Keyword list of options Body: see type HTTPoison.Request Options: see type HTTPoison.Request This function returns {:ok, response} or {:ok, async_response} if the request is successful, {:error, reason} otherwise. Examples request(:post, &quot;https://my.website.com&quot;, &quot;{\\&quot;foo\\&quot;: 3}&quot;, [{&quot;Accept&quot;, &quot;application/json&quot;}])"},{"ref":"CloudAPI.Client.html#request!/5","title":"CloudAPI.Client.request!/5","type":"function","doc":"Issues an HTTP request with the given method to the given url, raising an exception in case of failure. request!/5 works exactly like request/5 but it returns just the response in case of a successful request, raising an exception in case the request fails."},{"ref":"CloudAPI.Client.html#response_as/2","title":"CloudAPI.Client.response_as/2","type":"function","doc":""},{"ref":"CloudAPI.Client.html#run/1","title":"CloudAPI.Client.run/1","type":"function","doc":""},{"ref":"CloudAPI.Client.html#start/0","title":"CloudAPI.Client.start/0","type":"function","doc":"Starts HTTPoison and its dependencies."},{"ref":"CloudAPI.Client.html#stream_next/1","title":"CloudAPI.Client.stream_next/1","type":"function","doc":"Requests the next message to be streamed for a given HTTPoison.AsyncResponse. See request!/5 for more detailed information."},{"ref":"CloudAPI.Client.html#t:body/0","title":"CloudAPI.Client.body/0","type":"type","doc":""},{"ref":"CloudAPI.Client.html#t:headers/0","title":"CloudAPI.Client.headers/0","type":"type","doc":""},{"ref":"CloudAPI.Client.html#t:options/0","title":"CloudAPI.Client.options/0","type":"type","doc":""},{"ref":"CloudAPI.Client.html#t:params/0","title":"CloudAPI.Client.params/0","type":"type","doc":""},{"ref":"CloudAPI.Client.html#t:request/0","title":"CloudAPI.Client.request/0","type":"type","doc":""},{"ref":"CloudAPI.Client.html#t:url/0","title":"CloudAPI.Client.url/0","type":"type","doc":""},{"ref":"CloudAPI.Config.html","title":"CloudAPI.Config","type":"module","doc":""},{"ref":"CloudAPI.CreateImageFromMachine.html","title":"CloudAPI.CreateImageFromMachine","type":"module","doc":""},{"ref":"CloudAPI.CreateMachine.html","title":"CloudAPI.CreateMachine","type":"module","doc":""},{"ref":"CloudAPI.CreateMachine.Disk.html","title":"CloudAPI.CreateMachine.Disk","type":"module","doc":""},{"ref":"CloudAPI.CreateMachine.Volume.html","title":"CloudAPI.CreateMachine.Volume","type":"module","doc":""},{"ref":"CloudAPI.Datacenter.html","title":"CloudAPI.Datacenter","type":"module","doc":""},{"ref":"CloudAPI.FirewallRule.html","title":"CloudAPI.FirewallRule","type":"module","doc":""},{"ref":"CloudAPI.Image.html","title":"CloudAPI.Image","type":"module","doc":""},{"ref":"CloudAPI.Image.File.html","title":"CloudAPI.Image.File","type":"module","doc":""},{"ref":"CloudAPI.Image.Requirements.html","title":"CloudAPI.Image.Requirements","type":"module","doc":""},{"ref":"CloudAPI.Key.html","title":"CloudAPI.Key","type":"module","doc":""},{"ref":"CloudAPI.Machine.html","title":"CloudAPI.Machine","type":"module","doc":""},{"ref":"CloudAPI.Machine.Disk.html","title":"CloudAPI.Machine.Disk","type":"module","doc":""},{"ref":"CloudAPI.Machine.Snapshot.html","title":"CloudAPI.Machine.Snapshot","type":"module","doc":""},{"ref":"CloudAPI.Migration.html","title":"CloudAPI.Migration","type":"module","doc":""},{"ref":"CloudAPI.Migration.ProgressHistory.html","title":"CloudAPI.Migration.ProgressHistory","type":"module","doc":""},{"ref":"CloudAPI.NIC.html","title":"CloudAPI.NIC","type":"module","doc":""},{"ref":"CloudAPI.Network.html","title":"CloudAPI.Network","type":"module","doc":""},{"ref":"CloudAPI.Network.IP.html","title":"CloudAPI.Network.IP","type":"module","doc":""},{"ref":"CloudAPI.Package.html","title":"CloudAPI.Package","type":"module","doc":""},{"ref":"CloudAPI.Policy.html","title":"CloudAPI.Policy","type":"module","doc":""},{"ref":"CloudAPI.Role.html","title":"CloudAPI.Role","type":"module","doc":""},{"ref":"CloudAPI.Role.Member.html","title":"CloudAPI.Role.Member","type":"module","doc":""},{"ref":"CloudAPI.Role.Policy.html","title":"CloudAPI.Role.Policy","type":"module","doc":""},{"ref":"CloudAPI.VLAN.html","title":"CloudAPI.VLAN","type":"module","doc":""},{"ref":"CloudAPI.Volume.html","title":"CloudAPI.Volume","type":"module","doc":""}]